#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include "tasks.h"
#include "lsapi.h"

const int MAXTASKS = 16;
const int MAXICONS = 64;
const int MAXLEN = 256;
const int NUMTOKENS = 5;
const char AppName[] = "Tasks";
const char rcsRevision[] = "$Revision: 0.100 $";
const char rcsId[] = "$Id: tasks.cpp,v 0.100 1999/02/02 21:01:18 rdj Exp $";

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
void paintTask(int i);
void getTasks(void);
void createTask(int i, HWND handle);
void deleteTask(int i);
void ReadConfig(void);
int GetTaskByWnd(HWND hwnd);
int getAppIcon(int tasknr, char* target);
void deleteTask(int i);
int GetUnmovedNrTasks(void);
void RearrangeTasks(BOOL all);
void PaintTask(int i);
void GetNewTaskPos(int i);
void ToggleTasks(HWND caller, char* arg);
void CreateHints(HWND hWnd, char *txt, RECT *r);
void RemoveHints(HWND hWnd);
HICON getIconFromWindow(HWND hWnd, BOOL bBigIcon);

char defaultappicon[MAXLEN], backbmpname[MAXLEN], path[MAXLEN], miniconname[MAXLEN], fontname[MAXLEN];
int numTasks, numIcons, prevTasks, tasksize, fontsize, ScreenWidth, ScreenHeight, tasksx, tasksy, direction;
HINSTANCE dll;
HWND parent, mainWin, desktop, hints;
UINT timer;
HBITMAP backbmp = NULL;
BOOL titles, titlesminimized, autoarrange, movingtask, lbtnpressed, hidden, nohints;
COLORREF textcolor, backcolor;
POINT oldcursorpos;
HCURSOR normalcursor, movingcursor;
taskType tasks[MAXTASKS];
appIcon icons[MAXICONS];

int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
  return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
  int i;
  RECT r;
  dll = dllInst;
  strcpy(path, szPath);
  parent = ParentWnd;
  GetClientRect(GetDesktopWindow(),&r);
  ScreenWidth = r.right;
  ScreenHeight = r.bottom;
  movingtask = false;
  desktop = NULL;
  desktop = FindWindow("DesktopBackgroundClass", NULL);
  if (!desktop)
    desktop = GetDesktopWindow();
  {
	WNDCLASS wc;
    memset(&wc,0,sizeof(wc));
	wc.lpfnWndProc = WndProc;
	wc.hInstance = dllInst;
	wc.lpszClassName = AppName;
	wc.style = CS_DBLCLKS;
	if (!RegisterClass(&wc)) 
	{
	  MessageBox(parent,"Error registering window class","Tasks",MB_OK);
	  return 1;
	}
  }
  normalcursor = GetCursor();
  if (!normalcursor)
	LoadCursor(NULL, IDC_ARROW);
  movingcursor = LoadCursor(NULL, IDC_SIZEALL);
  for (i = 0; i < MAXTASKS; i++)
  {
	tasks[i].hwnd = NULL;
	tasks[i].bmp = NULL;
	tasks[i].appHandle = NULL;
	tasks[i].appTitle = NULL;
	tasks[i].icon = NULL;
  }
  ReadConfig();
  if (strcmp(".none", backbmpname))
    backbmp = LoadLSImage(backbmpname, NULL);
  else 
	backbmp = NULL;
  mainWin = CreateWindowEx(WS_EX_TOOLWINDOW, AppName, "", WS_CHILD, 0, 0, 1, 1, desktop, NULL, dll,	NULL);
  if (!mainWin) 
  {						   
    MessageBox(parent,"Error creating window","Tasks",MB_OK);
    return 1;
  }
  if (!nohints)
  {
	hints = CreateWindow(TOOLTIPS_CLASS,(LPSTR) NULL,TTS_ALWAYSTIP,	CW_USEDEFAULT,	CW_USEDEFAULT,	CW_USEDEFAULT,CW_USEDEFAULT,NULL,(HMENU) NULL, dll,	NULL);
	if (!hints) 
	{
	  MessageBox(parent, "Error creating hints window", "Tasks", MB_OK);
	  return 1;
	}
	SetWindowPos(hints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
  }
  SetWindowLong(mainWin, GWL_USERDATA, magicDWord);
  ShowWindow(mainWin, SW_HIDE);
  AddBangCommand("!TOGGLETASKS", ToggleTasks);
  hidden = false; // this is about the tasks itself not the main window, which is only used for the timer
  timer = SetTimer(mainWin, 0, 250, NULL);
  return 0;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
	case LM_GETREVID: 
	{
	  char *buf = (char *) lParam;
  	  if (wParam == 0) 
	  {
	    strcpy(buf, "tasks.dll: ");
		strcat(buf, &rcsRevision[11]);
		buf[strlen(buf)-1] = '\0';
	  } 
	  else if (wParam == 1) 
	  {
		strcpy(buf, &rcsId[1]);
		buf[strlen(buf)-1] = '\0';
	  } 
	  else 
		strcpy(buf, "");
	  return strlen(buf);
	}
	case WM_TIMER:
	{
	  getTasks();
      return 0;
	}
    case WM_QUERYENDSESSION:
      return SendMessage(parent,message,wParam,lParam);
	case WM_CREATE:
	  return 0;
	case WM_ERASEBKGND:
	  return 1; 
	case WM_PAINT:
	{
      int i = GetTaskByWnd(hwnd);
      if (i != -1)
		PaintTask(i);
	  return 0;
	}
	case WM_LBUTTONDOWN:
	{
	  int n = GetTaskByWnd(hwnd);
	  if (n != -1)
	  {
	    GetCursorPos(&oldcursorpos);
	    SetCapture(tasks[n].hwnd);
		lbtnpressed = true;
		movingtask = false;
	  }
	  return 0;
	}
	case WM_LBUTTONUP:
	{
	  int n = GetTaskByWnd(hwnd);
	  if (n != -1)
	  {
  	    POINT cursorpos;
	    GetCursorPos(&cursorpos);
  	    ReleaseCapture();
		lbtnpressed = false;
		if (GetCursor() != normalcursor)
	      SetCursor(normalcursor);
		if (abs(oldcursorpos.x - cursorpos.x) <= 5 && abs(oldcursorpos.y - cursorpos.y) <= 5 && tasks[n].hwnd == WindowFromPoint(cursorpos)) // click or canceled move
		{
		  if (!movingtask)
		  {
			if (IsIconic(tasks[n].appHandle))
			  ShowWindow(tasks[n].appHandle, SW_RESTORE);
			SendMessage(parent, LM_BRINGTOFRONT, 0, (long)tasks[n].appHandle);
			SetForegroundWindow(tasks[n].appHandle);
		  }
		  else // canceled a move, force a redraw (I hate this, shouldnt be necesary)
		  {
			ShowWindow(tasks[n].hwnd, SW_HIDE);
		    ShowWindow(tasks[n].hwnd, SW_SHOWNORMAL);
		  }
		}
		else // move
		{
		  tasks[n].x -= oldcursorpos.x - cursorpos.x;
		  tasks[n].y -= oldcursorpos.y - cursorpos.y;
		  tasks[n].IsMoved = true;
		  SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, tasksize, tasksize, 0); // SWP_NOZORDER|SWP_NOSIZE
		  ShowWindow(tasks[n].hwnd, SW_HIDE); // stupid redraw again
		  ShowWindow(tasks[n].hwnd, SW_SHOWNORMAL);
		  if (autoarrange)
			RearrangeTasks(false);
		}
	  }
	  return 0;
	}
	case WM_MOUSEMOVE:
	{
	  int n = GetTaskByWnd(hwnd);
	  if (lbtnpressed)
	  {
        POINT cursorpos;
		if (n != -1)
		{
	      GetCursorPos(&cursorpos);
	      if (abs(oldcursorpos.x - cursorpos.x) > 5 || abs(oldcursorpos.y - cursorpos.y) > 5 ||  tasks[n].hwnd != WindowFromPoint(cursorpos))
		  {
		    if (GetCursor() != movingcursor)
		      SetCursor(movingcursor);
			SetWindowPos(tasks[n].hwnd, 0, tasks[n].x - (oldcursorpos.x - cursorpos.x), tasks[n].y - (oldcursorpos.y - cursorpos.y), tasksize, tasksize, 0); //SWP_NOZORDER|SWP_NOSIZE
			movingtask = true;
		  }
		  else
		  {
		    if (GetCursor() != normalcursor)
		      SetCursor(normalcursor);
			SetWindowPos(tasks[n].hwnd, 0, tasks[n].x, tasks[n].y, tasksize, tasksize, 0); // SWP_NOZORDER|SWP_NOSIZE
		  }
		}
	  }
	  else
	  {
        if (!nohints) 
		{
		  MSG TooltipMessage;
		  TooltipMessage.hwnd=tasks[n].hwnd;
		  TooltipMessage.message=message;
		  TooltipMessage.wParam=wParam;
		  TooltipMessage.lParam=lParam;
		  SendMessage(hints,TTM_RELAYEVENT,0,(LPARAM)&TooltipMessage);
		  SetWindowPos(hints, HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);
		}
	  }
	  return 0;
	}
	case WM_MOUSEACTIVATE:
		PostMessage(parent, 9185, 0, 0); // Tells litestep it has been selected
		SendMessage(parent, 9183, (int)HIWORD(lParam), (int)LOWORD(lParam)); // Close any popup open
		if (HIWORD(lParam) == WM_LBUTTONDOWN) // te 10/30/98, Windows seems to be eating this?
			PostMessage(hwnd, WM_LBUTTONDOWN, 0, 0);
		return MA_ACTIVATE;
	case WM_ACTIVATE:
		SendMessage(parent, 9185, 0, 0); // Tells litestep it has been selected
		if (LOWORD(wParam)) SetActiveWindow(parent);
		return 0;
	case WM_RBUTTONUP: // Open popup menu
		SendMessage(parent, 9182, (int)HIWORD(lParam), (int)LOWORD(lParam));
		return 0;
	case WM_RBUTTONDOWN: // Close popup menu
	case WM_MBUTTONDOWN:
		SendMessage(parent, 9183, (int)HIWORD(lParam), (int)LOWORD(lParam));
		return 0;
	case WM_KEYDOWN: 
	case WM_KEYUP:
	{	
	  PostMessage(parent,message,wParam,lParam);
	}
	return 0;
  }
  return DefWindowProc(hwnd,message,wParam,lParam);
}

void quitModule(HINSTANCE dllInst)
{
  int i;
  if (timer)
    KillTimer(NULL, timer);
  for(i = 0; i < numTasks; i++)
    deleteTask(i);
  for(i = 0; i < numIcons; i++)
  {
	delete [] icons[numIcons].name;
	delete [] icons[numIcons].bitmap;
  }
  if (backbmp)
    DeleteObject(backbmp);
  DestroyWindow(mainWin);
  if (!nohints) 
	DestroyWindow (hints);
  UnregisterClass(AppName,dllInst);
}

void getTasks(void)
{
  windowType * winList = NULL;
  char tmptitle[MAXLEN];
  int m, n, maxWin;
  prevTasks = numTasks;
  numTasks = 0;		  
  winList = (windowType *)SendMessage(parent, LM_WINLIST, 0, 0);
  maxWin = (int) SendMessage(parent, LM_WINLIST, 1, 0);
  for (n = 0; n < maxWin && winList[n].Handle; n++)
  {
	if (winList[n].Handle != NULL && numTasks < MAXTASKS)
	{
	  GetWindowText(winList[n].Handle, (char *)&tmptitle, MAXLEN);
	  if (winList[n].Handle != tasks[numTasks].appHandle)
	  { 
		deleteTask(numTasks);
	    createTask(numTasks, winList[n].Handle);
	    numTasks++;
	  }
	  else if (tasks[numTasks].IsIconic != IsIconic(winList[n].Handle))
	  {
		tasks[numTasks].IsIconic = IsIconic(winList[n].Handle);
		if (!hidden)
		{
		  ShowWindow(tasks[numTasks].hwnd, SW_HIDE);
		  ShowWindow(tasks[numTasks].hwnd, SW_SHOWNORMAL);		
		  // there must be a better way to force a redraw
		}
		numTasks++;
	  }
	  else if (strcmp(tmptitle, tasks[numTasks].appTitle) != 0)
	  {
		  if (!nohints)
		  {
			TOOLINFO ti;
		    ti.cbSize = sizeof(TOOLINFO);
	  	    ti.hwnd = tasks[n].hwnd;
	        ti.uId = 0;
	        ti.lpszText = tmptitle;
		    SendMessage(hints, TTM_UPDATETIPTEXT, 0, (LPARAM) (LPTOOLINFO) &ti);
		    delete [] tasks[numTasks].appTitle;
		    tasks[numTasks].appTitle = new char[strlen(tmptitle) + 1];
		    strcpy(tasks[numTasks].appTitle, tmptitle);
		    numTasks++;
		  }
	  }
	  else
	    numTasks++;
	}
  }
  for (m = numTasks; m < prevTasks; m++)
	deleteTask(m);
}

int GetTaskByWnd(HWND hwnd)
{
  int i;
  for (i = 0;i < numTasks ; i++)
    if (tasks[i].hwnd == hwnd)
	  return i;
  return -1;
}

void createTask(int i, HWND handle)
{
  RECT r;
  HWND hWnd = NULL;
  char frontimage[MAXLEN], title[MAXLEN];
  hWnd = CreateWindowEx(WS_EX_TOOLWINDOW, AppName, "", WS_CHILD, 0, 0,	tasksize, tasksize, desktop, NULL, dll,	NULL);
  if (!hWnd) 
  {						   
    MessageBox(parent,"Error creating window","Tasks",MB_OK);
    return;
  }
  tasks[i].hwnd = hWnd;
  tasks[i].appHandle = handle;
  SetWindowLong(tasks[i].hwnd, GWL_USERDATA, magicDWord);
  GetWindowText(handle, (char *)&title, MAXLEN);
  tasks[i].appTitle = new char[strlen(title) + 1];
  strcpy(tasks[i].appTitle, title);
  GetNewTaskPos(i);
  tasks[i].IsIconic = IsIconic(handle);
  tasks[i].IsMoved  = false;
  getAppIcon(i, frontimage);
  if (strcmp(".extract", frontimage) != 0)
	tasks[i].bmp = LoadLSImage(frontimage, NULL);
  else
	  tasks[i].icon = getIconFromWindow(tasks[i].appHandle, (tasksize > 32) ? true: false);
  SetWindowPos(tasks[i].hwnd, 0, tasks[i].x, tasks[i].y, tasksize, tasksize, 0);
  if (!hidden)
	ShowWindow(tasks[i].hwnd, SW_SHOWNORMAL);
  else
	ShowWindow(tasks[i].hwnd, SW_HIDE);
  GetClientRect(tasks[i].hwnd, &r);
  CreateHints(tasks[i].hwnd, tasks[i].appTitle, &r);
  InvalidateRect(tasks[i].hwnd, &r, TRUE);
}

void deleteTask(int i)
{
  RemoveHints(tasks[i].hwnd);
  if (tasks[i].hwnd)
    DestroyWindow(tasks[i].hwnd);
  if (tasks[i].bmp)
    DeleteObject(tasks[i].bmp);
  if (tasks[i].appTitle)
    delete [] tasks[i].appTitle;
  tasks[i].appHandle = NULL;
  tasks[i].hwnd = NULL;
  tasks[i].bmp = NULL;
  tasks[i].icon = NULL;  
  tasks[i].appTitle = NULL;
}

void ReadConfig(void)
{
  FILE * f;
  unsigned int i;
  char * token[NUMTOKENS];
  char tmp[MAXLEN], buffer[1024], extra[1024];
  GetRCString("TasksDirection", tmp, "right", MAXLEN);
  direction = 2; // right is default
  if (strcmp(tmp, "up") == 0)
	direction = 1;
  else if (strcmp(tmp, "right") == 0)
	direction = 2;
  else if (strcmp(tmp, "down") == 0)
	direction = 3;
  else if (strcmp(tmp, "left") == 0)
	direction = 4;
  GetRCString("TasksBackPix", backbmpname, ".none", MAXLEN);
  tasksize = GetRCInt("TasksSize", 64);
  tasksx = GetRCInt("TasksX", 0);
  tasksy = GetRCInt("TasksY", -1);
  GetRCString("DefaultAppIcon", defaultappicon, ".extract", MAXLEN);
  titles = GetRCBool("TasksTitlesAlways", TRUE);
  titlesminimized = GetRCBool("TasksTitlesWhenMinimized", TRUE);
  autoarrange = GetRCBool("AutoArrangeTasks", TRUE);
  nohints = GetRCBool("NoTaskHints", TRUE);
  GetRCString("TasksFont", fontname, "Arial", MAXLEN);
  textcolor = GetRCColor("TasksTextColor", 0xFFFFFF);
  backcolor = GetRCColor("TasksBackColor", 0xFF00FF);
  fontsize = GetRCInt("TasksFontSize", 8);
  numIcons = 0;
  f = LCOpen(NULL);
  if (!f) 
	return;
  for (i = 0; i < NUMTOKENS; i++)
    token[i] = new char[MAXLEN];
  while (LCReadNextConfig (f, "*Task", buffer, sizeof (buffer)))
  {
	 int count;
	 count = LCTokenize (buffer, token, NUMTOKENS, extra);
	 if (count >= 3)
	 {
	   icons[numIcons].name = new char[strlen(token[1])+1];
	   icons[numIcons].bitmap = new char[strlen(token[2])+1];
	   strcpy(icons[numIcons].name, token[1]);
	   strcpy(icons[numIcons].bitmap, token[2]);
	   numIcons++;
	 }
  }
  LCClose(f);
  for (i = 0; i < NUMTOKENS; i++)
    delete [] token[i];
 }

int getAppIcon(int tasknr, char* target)
{
  int i;
  for (i = 0; i < numIcons; i++)
  {
	if (strstr(tasks[tasknr].appTitle, icons[i].name))
	{
	  strcpy (target, icons[i].bitmap);
	  return 1;
	}
  }
  strcpy (target, defaultappicon);
  return 1;
}

int GetUnmovedNrTasks(void)
{
  int result = 0;
  for (int i = 0; i < numTasks; i++)
    if (!tasks[i].IsMoved)
	  result++;
  return result;
}

void RearrangeTasks(BOOL all)
{
  int j = 0;
  for (int i = 0; i < numTasks; i++)
  {
	if (all || !tasks[i].IsMoved)
	{
	  if (direction == 1) // up
	  {
		tasks[i].x = tasksx;
		if (tasksy >= 0)
		  tasks[i].y = tasksy - (j * tasksize);
		else
		  tasks[i].y = ScreenHeight - tasksy - (j * tasksize);
	  }
	  else if(direction == 2) // right
	  {
	    tasks[i].x = tasksx + (j * tasksize);
	    if (tasksy >= 0) 
		  tasks[i].y = tasksy;
	    else // default to bottom screen
		  tasks[i].y = ScreenHeight - tasksize;
	  }
	  else if(direction == 3) // down
	  {
		tasks[i].x = tasksx;
		if (tasksy >= 0)
		  tasks[i].y = tasksy + (j * tasksize);
		else // default to top of screen
		  tasks[i].y = j * tasksize;
	  }
	  else if(direction == 4) // left
	  {
	    tasks[i].x = tasksx - (j * tasksize);
	    if (tasksy >= 0) 
		  tasks[i].y = tasksy;
	    else // default to bottom screen
		  tasks[i].y = ScreenHeight - tasksize;
	  }
      SetWindowPos(tasks[i].hwnd, 0, tasks[i].x, tasks[i].y, tasksize, tasksize, 0);
	  j++;
	}
  }
}

void GetNewTaskPos(int i)
{
  if (direction == 1) // up
  {
    tasks[i].x = tasksx;
	if (tasksy >= 0)
	  tasks[i].y = tasksy - ((autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize);
	else // default to bottom
	  tasks[i].y = ScreenHeight - tasksize - ((autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize);
  }
  else if (direction == 2) //right
  {
    tasks[i].x = tasksx + ((autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize);
    if (tasksy >= 0)
      tasks[i].y = tasksy;
    else // default to bottom screen
      tasks[i].y = ScreenHeight - tasksize;
  }
  else if (direction == 3) //down
  {
    tasks[i].x = tasksx;
	if (tasksy >= 0)
	  tasks[i].y = tasksy + ((autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize);
	else // default to top of screen
	  tasks[i].y = (autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize;
  }
  else if (direction == 4) //left
  {
    tasks[i].x = tasksx - ((autoarrange ? GetUnmovedNrTasks(): numTasks) * tasksize);
    if (tasksy >= 0)
      tasks[i].y = tasksy;
    else // default to bottom screen
      tasks[i].y = ScreenHeight - tasksize;
  }
}

void PaintTask(int i)
{
  PAINTSTRUCT ps;
  BITMAP bmInfo;
  HDC hdc = BeginPaint(tasks[i].hwnd,&ps);
  HDC src = CreateCompatibleDC(NULL);
  if (backbmp)
  {
    SelectObject(src, backbmp);
    TransparentBltLS(hdc, 0, 0, tasksize, tasksize, src, 0, 0, RGB(255, 0, 255));
  }
  if (tasks[i].bmp)
  {
    GetObject(tasks[i].bmp, sizeof(bmInfo), &bmInfo);
    if (bmInfo.bmWidth > tasksize)
      bmInfo.bmWidth = tasksize;
    if (bmInfo.bmHeight > tasksize) 
      bmInfo.bmHeight = tasksize;
    SelectObject(src, tasks[i].bmp);
	TransparentBltLS(hdc, (tasksize/2)-(bmInfo.bmWidth/2), (tasksize/2)-(bmInfo.bmHeight/2), bmInfo.bmWidth, bmInfo.bmHeight, src, 0, 0, RGB(255,0,255));
  }
  if (tasks[i].icon)
  {
	int iconsize, pos;
	iconsize = (tasksize > 32) ? 32 : 16;
	pos = (tasksize / 2) - (iconsize / 2);
	if (iconsize == 32)
	  DrawIconEx(hdc, pos, pos, tasks[i].icon, 32, 32, 0, NULL, DI_NORMAL);
	else
      DrawIconEx(hdc, pos, pos, tasks[i].icon, 16, 16, 0, NULL, DI_NORMAL);
  }
  if (titles || (titlesminimized && tasks[i].IsIconic))
  {
    char title[MAXLEN];
    HBRUSH backbrush;
    HFONT titlefont, oldfont;
    RECT r;
	HPEN pen, oldpen;
    GetClientRect(tasks[i].hwnd, &r);
    r.bottom = fontsize + 2;
	if (backcolor != 0x00FF00FF)
	{
      backbrush = CreateSolidBrush(backcolor);
      FillRect(hdc, &r, backbrush);
	  // 2 white lines
	  pen = CreatePen(PS_SOLID, 1, RGB(255,255,255));
	  oldpen = (HPEN) SelectObject(hdc, pen);
	  MoveToEx(hdc, r.left, r.top, NULL);
	  LineTo(hdc, r.right, r.top);
      MoveToEx(hdc, r.left, r.top, NULL);
	  LineTo(hdc, r.left, r.bottom);
	  SelectObject(hdc, oldpen);
      DeleteObject(pen);
	  // 2 gray lines
      pen = CreatePen(PS_SOLID, 1, RGB(0x40,0x40,0x40));
      oldpen = (HPEN) SelectObject(hdc, pen);
	  MoveToEx(hdc, r.left + 1, r.bottom -1, NULL);
      LineTo(hdc, r.right - 1, r.bottom - 1);
	  LineTo(hdc, r.right - 1, r.top + 1);
      SelectObject(hdc, oldpen);
      DeleteObject(pen);
	}
	r.left += 2;
	r.right -= 2;
    int len = strlen(tasks[i].appTitle);
    titlefont = CreateFont(fontsize, 0, 0, 0, 0, FALSE, FALSE, FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, fontname);
    oldfont = SelectObject(hdc, titlefont);
    SetBkMode(hdc, TRANSPARENT);
    SetTextColor(hdc, textcolor);
    GetWindowText(tasks[i].appHandle, (char *)&title, MAXLEN);
    DrawText(hdc, title, len, &r, DT_VCENTER|DT_SINGLELINE|DT_END_ELLIPSIS);
    SelectObject(hdc, oldfont);
    DeleteObject(titlefont);
    DeleteObject(backbrush);
  }
  DeleteDC(src);
  EndPaint(tasks[i].hwnd,&ps);
}

HICON getIconFromWindow(HWND hWnd, BOOL bBigIcon) // taken from the re5ource popups, much credit to re5ource :)
{
   HICON hIcon = NULL;

   int nBigOrSmall = bBigIcon ? ICON_BIG : ICON_SMALL;
   int nBigOrSmall2 = bBigIcon ? GCL_HICON : GCL_HICONSM;

   SendMessageTimeout(hWnd, WM_GETICON, nBigOrSmall, 0, 
      SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);
   if(!hIcon) hIcon = (HICON)GetClassLong(hWnd, nBigOrSmall2);
   if(!hIcon) SendMessageTimeout(hWnd, WM_GETICON, nBigOrSmall, 1, 
      SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);
   if(!hIcon) hIcon = (HICON)GetClassLong(hWnd, nBigOrSmall2);
   if(!hIcon) SendMessageTimeout(hWnd, WM_QUERYDRAGICON, nBigOrSmall, 
      0, SMTO_ABORTIFHUNG, 1000, (PULONG)&hIcon);
   
   return hIcon;
}

void ToggleTasks(HWND caller, char* arg)
{
  for (int i = 0; i < numTasks; i++)
  {
	if (hidden)
	  ShowWindow(tasks[i].hwnd, SW_SHOWNORMAL);
	else
	  ShowWindow(tasks[i].hwnd, SW_HIDE);
  }
  hidden = !hidden;
}

void CreateHints(HWND hWnd, char *txt, RECT *r) { // from the original ls code (shortcuts)
	TOOLINFO ti;    // tool information
	if (nohints)
	{
		return;
	}

	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = txt;
	ti.rect = *r;

	SendMessage(hints, TTM_ADDTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}

void RemoveHints(HWND hWnd) { // from the original ls code (shortcuts)
	TOOLINFO ti;    // tool information
	RECT r={0,0,0,0};

	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = 0;
	ti.hwnd = hWnd;
	ti.hinst = dll;
	ti.uId = 0;
	ti.lpszText = NULL;
	ti.rect = r;

	SendMessage(hints, TTM_DELTOOL, 0, (LPARAM) (LPTOOLINFO) &ti);
}
